`timescale 1ns / 1ns
`define CLK_PERIOD 20


module tb_uart_rx();


reg sclk;
reg srstn;
reg ssend_en;
reg [2:0] sbaud_set;
reg [7:0] sdata_byte;
wire suart_txd;
wire stx_done;
wire suart_state;
wire [7:0] sdata_byte_out;
wire srx_done;


initial sclk<=0;
always #10 sclk<=~sclk;

uart_tx u1(
            .clk        (sclk),
            .rstn       (srstn),
            .send_en    (ssend_en),
            .baud_set   (sbaud_set),
            .data_byte  (sdata_byte),
            .uart_txd   (suart_txd),
            .tx_done    (stx_done),
            .uart_state (suart_state)
    );

uart_rx u2(
            .clk       (sclk),
            .rstn      (srstn),
            .rxd       (suart_txd),
            .baud_set  (sbaud_set),
            .data_byte (sdata_byte_out),
            .rx_done   (srx_done)
    );

initial begin
        srstn = 1'b0;
        sdata_byte = 8'd0;
        ssend_en = 1'd0;
        sbaud_set = 3'd4;
        #(`CLK_PERIOD*20 + 1 );
        srstn = 1'b1;
        #(`CLK_PERIOD*50);

    //send first byte
        sdata_byte = 8'haa;
        ssend_en = 1'd1;
        #`CLK_PERIOD;
        ssend_en = 1'd0;

        @(posedge stx_done)
        #(`CLK_PERIOD*5000);

    //send second byte
        sdata_byte = 8'h55;
        ssend_en = 1'd1;
        #`CLK_PERIOD;
        ssend_en = 1'd0;

        @(posedge stx_done)
        #(`CLK_PERIOD*5000);
        $stop;
end

endmodule
